/**
 * zmia-slow.cpp
 * 
 * author: krasimir.georgiev
 */

#include <cstdio>
using namespace std;

int const max_n = (1 << 19);

int du[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};

char dirs[max_n];

void get(int p, int& x, int& y) {
	x = y = 0;
	char dir = 0;
	for (int i = 0; i < p; ++i) {
		dir = (dir + dirs[i]) % 4;
		x += du[dir][0];
		y += du[dir][1];
	}
}

void add(int p, char dir) {
	dirs[p] = (dirs[p] + dir) % 4;
}

int main() {
	int n, q;
	scanf("%d%d", &n, &q);
	while (q--) {
		char c; int i;
		scanf(" %c %d", &c, &i);
		if (c == 'L') {
			int x, y;
			get(i, x, y);
			printf("%d %d\n", x, y);
		}
		else {
			char d;
			scanf(" %c", &d);
			add(i, d == '+' ? 1 : 3);
		}
	}
}
