/**
 * zmia-tstgen.cpp
 * 
 * author: krasimir.georgiev
 */

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <algorithm>
using namespace std;

const int max_q = (1 << 19);
int id[max_q];

int main() {
	srand(time(0));
	int n, q, l;
	scanf("%d%d%d", &n, &q, &l);
	printf("%d %d\n", n, q);
	for (int i = 0; i < q; ++i) {
		id[i] = i;
	}

	random_shuffle(id, id + q);

	for (int i = 0; i < q; ++i) {
		if (id[i] < l) {
			int p = 1 + abs(rand()) % n;
			printf("L %d\n", p);
		}
		else {
			int p = abs(rand()) % n;
			int d = abs(rand()) % 2;
			printf("R %d %c\n", p, d ? '+' : '-');
		}
	}

	return 0;
}
